<?php

class Netgsmsms
{
    private $usercode;
    private $password;
    private $title;
    private $language = '';
    private $startDate;

    public function __construct($usercode,$password,$title='', $TR_Char='') {     //WP USE
        $this->usercode = trim($usercode);
        $this->password = $password;
        $this->title = $title;
        $this->language = '';
    }

    public function setStartDate($startDate)
    {
        $this->startDate = $startDate;
    }
    public function getStartDate()
    {
        if ($this->startDate == ''){
            return '';
        }
        return date('dmYHi', strtotime($this->startDate));
    }

    public function sendSMS($phone,$mesaj){       //WP USE
        
        $phones = array();
        $parts = explode(',',$phone);
        foreach ($parts as $value){
           if($value!=''){
               array_push($phones,$value);
           }
        }
        $number ="";
        foreach ($phones as $value){
            $number .= $value;
        }
        
        $body = array(
            'phone' => $number,
            'body' => $mesaj
        );
        
        $PostAdress = 'https://s2.wha-api.com/Instance'.$this->usercode.'/sendMessage?token='.$this->password;
        $response = wp_remote_post($PostAdress, array(
            'headers'     => array('Content-Type' => 'application/json; charset=utf-8'),
            'body'        => json_encode($body),
            'method'      => 'POST',
            'data_format' => 'body',
        ));
                                   
        $response = $this->responseDecoder($response)['body'];
        return $response;
    }

    /*
     * otp sms gönderimi
     */
    public function sendOTPSMS($phone, $message){
        
        $body = array(
            'phone' => $phone,
            'body' => $message
        );
        
         $PostAdress = 'https://s2.wha-api.com/Instance'.$this->usercode.'/sendMessage?token='.$this->password;
            $response = wp_remote_post($PostAdress, array(
            'headers'     => array('Content-Type' => 'application/json; charset=utf-8'),
            'body'        => json_encode($body),
            'method'      => 'POST',
            'data_format' => 'body',
        ));
                                   
        $response = $this->responseDecoder($response)['body'];
        
        return $response;
    }



    public function addContact($first_name, $last_name, $phone, $groupname = 'Müşteriler') {   //WP USE
        $xml = array('body'=>'<?xml version="1.0" encoding="iso-8859-9"?>
        <main>
            <usercode>'.$this->usercode.'</usercode>
            <pwd>'.$this->password.'</pwd>
            <grup>'.$groupname.'</grup>
            <tel>
                <ad><![CDATA['.$first_name.']]></ad>
                <soyad><![CDATA['.$last_name.']]></soyad>
                <telefon><![CDATA['.$phone.']]></telefon>
            </tel>
        </main>');
        $response = wp_remote_post( 'http://api.netgsm.com.tr/contacts/group/add', $xml );
        return $this->responseDecoder($response)['body'];
    }

    public function netgsm_GetKredi($user,$pass) {     //WP USE
        $response = wp_remote_get( "https://api.netgsm.com.tr/get_kredi.asp?usercode=$user&password=$pass" );
        $data = explode(' ', $this->responseDecoder($response)['body']);
        if($data[0]!='30') {
            if(isset($data[2]) && isset($data[2])=='AdetSMS')
                $tip = 'SMS';
            else
                $tip = 'Kredi';
            if ($data[1] > 0) {
                $result = array('giris'=>'success', 'durum' => 'success', 'mesaj'=>'', 'kredi' => $data[1], 'tipmsj' => ' Kalan '.$tip);
            } else {
                $result = array('giris'=>'success', 'durum' => 'warning', 'mesaj'=>' Bakiye Satın Al',  'kredi' => $data[1],  'tipmsj' => ' Kalan '.$tip);
            }
        }
        else{
            $result = array('giris'=>'error', 'durum'=>'error', 'mesaj'=>'Geçersiz kullanıcı adı , şifre veya kullanıcınızın API erişim izninin olmadığını gösterir.');
        }
        return $result;
    }

    public function netgsm_GetPaket($user,$pass) {     //WP USE
        $response = wp_remote_get( "https://api.netgsm.com.tr/get_kredi.asp?usercode=$user&password=$pass&tip=1" );
        $data = explode(' ', $this->responseDecoder($response)['body']);
        if($data[0]=='30') {
            $result = array('giris'=>'error', 'durum'=>'error', 'mesaj'=>'Geçersiz kullanıcı adı , şifre veya kullanıcınızın API erişim izninin olmadığını gösterir.');
        }
        elseif ($data[0]=='40') {
            $result = array('giris'=>'success', 'durum'=>'error', 'mesaj'=>'Arama kriterlerinize göre listelenecek kayıt olmadığını ifade eder.');
        }
        else {
            if ($data[0] > 0) {
                $result = array('giris'=>'success', 'durum' => 'success', 'mesaj'=>'', 'kredi' => $data[0], 'tipmsj' => ' Kalan SMS'); // sms
            }
            else{
                $result = array('giris'=>'success', 'durum' => 'warning', 'mesaj'=>' Bakiye Satın Al', 'kredi' => $data[0], 'tipmsj' => ' Kalan SMS');
            }
        }
        return $result;
    }

    public function netgsm_GirisSorgula($user,$pass)    //WP USE
    {
        
        $response = wp_remote_get( "https://s2.wha-api.com/Instance$user/CheckAuth?token=$pass" );
        $response = json_decode($response['body'],true);
        if ($response['status'] == 'error') {
            $result = array(
                'durum' => $response['status'],
                'icon' => 'warning',
                'mesaj' => $response['message'],
                'btnkontrol'=>'disabled',
                'href'=>'#'
            );
        } else {
                $result = array(
                'durum' => $response['status'],
                'icon' => 'warning',
                'mesaj' => $response['device_status'],
                'btnkontrol'=>'enabled',
                'href'=>'#'
            );
        }
       
        return json_encode($result);
    }

   

 
    public function getphoneClear($phone){
        $unwanted = array(' ', '+', '(', ')', '.', '-', '&amp;', 'nbsp;'  );
        $replace    = array('', '', '', '', '', '', '', '' );
        $result      = str_replace($unwanted, $replace, $phone);
        return $result;
    }

    public function timeconvert($time){
        if($time<60){
            $second = ceil($time);
            if($second<10){
                $second = '0'.$second;
            }
            return '00:00:'.$second;
        }
        $minute = floor($time/60);
        $second = $time%60;
        if($minute<60){
            if($minute<10){
                $minute = '0'.$minute;
            }
            if($second<10){
                $second = '0'.$second;
            }
            return '00:'.$minute.':'.$second;
        }
        $hour = floor($minute/60);
        $minute = $minute%60;
        if($hour<10){
            $hour = '0'.$hour;
        }
        if($minute<10){
            $minute = '0'.$minute;
        }
        if($second<10){
            $second = '0'.$second;
        }
        return $hour.':'.$minute.':'.$second;
    }

    private function responseDecoder($response)
    {
        if (is_array($response) && !empty($response['body']))
        {
            return $response;
        }
        $array['body'] = '';
        return $array;
    }
}

